DAY39: 动态规划不同路径问题62

Leetcode: 62 不同路径

机器人从(0 , 0) 位置出发,到(m - 1, n - 1)终点。

基本思路

1、确定dp数组(dp table)以及下标的含义

dpij :表示从(0 ,0)出发,到(i, j) 有dpij条不同的路径。

2、确定递推公式

想要求dpij,只能有两个方向来推导出来,即dpi - 1j 和 dpij - 1。所以dpij = dpi - 1j + dpij - 1。

3、dp数组的初始化

dpi0一定都是1,因为从(0, 0)的位置到(i, 0)的路径只有一条,那么dp0j也同理。

时间复杂度:O(m × n)

空间复杂度:O(m × n)

想不出来的时候,可以想想最后的步骤是由上一步怎么导出的。

复制代码
class Solution {
public:
    int uniquePaths(int m, int n) {
        vector<vector<int>> dp(m, vector<int>(n,0));//初始化二维向量
        for(int i = 0; i < m; i++){
            dp[i][0] = 1;//初始化起始
        } 
        for(int i = 0; i < n; i++){
            dp[0][i] = 1;
        }
        for(int i = 1; i < m; i++){
            for(int j = 1; j < n; j++){
                dp[i][j] = dp[i - 1][j]+ dp[i][j - 1];//递推公式
            }
        }
        return dp[m - 1][n - 1];

    }
};

当然也可以使用数论的方法。最后获得组合的方法如下。

但是这道题目要防止两个int相乘出现溢出的情况,所以要对两数相乘做特殊处理。需要在计算分子的时候,不断除以分母。

代码如下

代码随想录

时间复杂度:O(m)

空间复杂度:O(1)

复制代码
class Solution {
public:
    int uniquePaths(int m, int n) {
        long long numerator = 1; // 分子
        int denominator = m - 1; // 分母
        int count = m - 1;
        int t = m + n - 2;
        while (count--) {
            numerator *= (t--);
            while (denominator != 0 && numerator % denominator == 0) {
                numerator /= denominator;
                denominator--;
            }
        }
        return numerator;
    }
};

Leetcode: 63 不同路径 II

这道题与上道题不一样的点,在于现在的的路径出现了障碍物。

1、dp数组的初始化

dpi0一定都是1,但是如果遇到障碍物,那么后面的所有数组都是0,是无法达到的道路。

2、确定递推公式

想要求dpij,只能有两个方向来推导出来,即dpi - 1j 和 dpij - 1。所以dpij = dpi - 1j + dpij - 1。如果出现障碍物,就跳过元素,这样这个元素还是0,那么即使相加相当于只有一个方向的信息。因此我们的递推公式还是dpij = dpi - 1j + dpij - 1。遇到障碍物之后都是0。

时间复杂度:O(n × m)

空间复杂度:O(n × m)

复制代码
class Solution {
public:
    int uniquePathsWithObstacles(vector<vector<int>>& obstacleGrid) {
        int m = obstacleGrid.size();
        int n = obstacleGrid[0].size();//注意维度的选择
        vector<vector<int>> dp(m, vector<int>(n,0));
        if (obstacleGrid[m - 1][n - 1] == 1 || obstacleGrid[0][0] == 1) //如果在起点或终点出现了障碍,直接返回0
            return 0;
        for(int i = 0; i < m && obstacleGrid[i][0] == 0; i++) dp[i][0] = 1;
        for(int i = 0; i < n && obstacleGrid[0][i] == 0; i++) dp[0][i] = 1;
        for(int i = 1; i < m; i++){
            for(int j = 1; j < n; j++){
                if(obstacleGrid[i][j] == 1) continue;
                dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
            }
        }
        return dp[m - 1][n - 1];

    }
};
相关推荐
只愿云淡风清2 分钟前
正则表达式学习笔记 02:基础语法
笔记·学习·正则表达式
eggwyw10 分钟前
关于C++为什么不加入垃圾回收机制解析
开发语言·c++
jktantan11 分钟前
注解式脱敏:用 Jackson 的 ContextualSerializer 做字段级策略(一)
spring boot·后端·算法·spring cloud·系统架构
曦樂~10 小时前
Cpp面筋
c语言·c++
道尔柯南10 小时前
C++ string 类详解:从常用接口到深拷贝,彻底掌握字符串处理
android·java·c++
希和202711 小时前
考研英语阅读词汇笔记|城市野径、抄近道步道(非正式小路)
笔记·考研
Dream it possible!13 小时前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划
心抵鹊13 小时前
算法之双指针系列(一)
算法·leetcode
一个人旅程~13 小时前
关于imac27inch因改短用户名导致混合硬盘和系统崩溃的问题分析与故障解决
经验分享·笔记·macos·新浪微博
十二13 小时前
【洛谷题解】P1083 [NOIP 2012 提高组] 借教室(二分答案 + 差分)
数据结构·c++·算法·蓝桥杯